/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details:
 *
 * Copyright (C) 2008 Novell, Inc.
 * Copyright (C) 2009 Red Hat, Inc.
 * Copyright (C) 2011 Novatel Wireless, Inc.
 */

#ifndef MM_MODEM_LTE_CARD_H
#define MM_MODEM_LTE_CARD_H

#include <mm-modem.h>

#define MM_TYPE_MODEM_LTE_CARD      (mm_modem_lte_card_get_type ())
#define MM_MODEM_LTE_CARD(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj), MM_TYPE_MODEM_LTE_CARD, MMModemLteCard))
#define MM_IS_MODEM_LTE_CARD(obj)   (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MM_TYPE_MODEM_LTE_CARD))
#define MM_MODEM_LTE_CARD_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), MM_TYPE_MODEM_LTE_CARD, MMModemLteCard))

#define MM_MODEM_LTE_CARD_SUPPORTED_BANDS "supported-bands"
#define MM_MODEM_LTE_CARD_SUPPORTED_MODES "supported-modes"
#define MM_MODEM_LTE_CARD_SIM_IDENTIFIER  "sim-identifier"

#define MM_MODEM_LTE_CARD_SIM_PIN "sim-pin"
typedef struct _MMModemLteCard MMModemLteCard;

#define MM_MODEM_LTE_CARD_UNLOCK_RETRIES_NOT_SUPPORTED 999

typedef struct _MMModemLteCard MMModemGsmCard;

struct _MMModemLteCard {
    GTypeInterface g_iface;

    /* Methods */
    void (*get_imei) (MMModemLteCard *self,
                      MMModemStringFn callback,
                      gpointer user_data);

    void (*get_imsi) (MMModemLteCard *self,
                      MMModemStringFn callback,
                      gpointer user_data);

    void (*get_unlock_retries) (MMModemLteCard *self,
                              const char *pin_type,
                              MMModemUIntFn callback,
                              gpointer user_data);

    void (*get_operator_id) (MMModemLteCard *self,
                             MMModemStringFn callback,
                             gpointer user_data);

    void (*get_spn) (MMModemGsmCard *self,
                     MMModemStringFn callback,
                     gpointer user_data);

    void (*send_pin) (MMModemLteCard *self,
                      const char *pin,
                      MMModemFn callback,
                      gpointer user_data);

    void (*enable_pin) (MMModemLteCard *self,
                        const char *pin,
                        gboolean enabled,
                        MMModemFn callback,
                        gpointer user_data);

    void (*change_pin) (MMModemLteCard *self,
                        const char *old_pin,
                        const char *new_pin,
                        MMModemFn callback,
                        gpointer user_data);
};

GType mm_modem_lte_card_get_type (void);

void mm_modem_lte_card_get_imei (MMModemLteCard *self,
                                 MMModemStringFn callback,
                                 gpointer user_data);

void mm_modem_lte_card_get_imsi (MMModemLteCard *self,
                                 MMModemStringFn callback,
                                 gpointer user_data);

void mm_modem_lte_card_get_unlock_retries (MMModemGsmCard *self,
                                           const char *pin_type,
                                           MMModemUIntFn callback,
                                           gpointer user_data);

void mm_modem_lte_card_get_operator_id (MMModemGsmCard *self,
                                        MMModemStringFn callback,
                                        gpointer user_data);

void mm_modem_lte_card_get_spn (MMModemGsmCard *self,
                                MMModemStringFn callback,
                                gpointer user_data);

void mm_modem_lte_card_send_pin (MMModemGsmCard *self,
                                 const char *pin,
                                 MMModemFn callback,
                                 gpointer user_data);

void mm_modem_lte_card_enable_pin (MMModemGsmCard *self,
                                   const char *pin,
                                   gboolean enabled,
                                   MMModemFn callback,
                                   gpointer user_data);

void mm_modem_lte_card_change_pin (MMModemLteCard *self,
                                   const char *old_pin,
                                   const char *new_pin,
                                   MMModemFn callback,
                                   gpointer user_data);

#endif /* MM_MODEM_LTE_CARD_H */
